var rodeo = rodeo || {};

rodeo.rodeoProductSetup = (function (el) {
    var format_css, container, layout_type, api_url, show_no_of_products, show_pagination, page = 1, category_hashtag, company_name;

    // get specifics from the respond system to send off to the api

    layout_type = el.getAttribute('layout_type');
    
    if(window.location.hash){
        var urlPagisnation=window.location.href;
        if(urlPagisnation.includes("#page-")){
            urlPagisnation=urlPagisnation.split("#page-")
            page = urlPagisnation[1];
        }
    }
    
    if (layout_type === "list") {
        container = el.querySelector('#template_huntItemShellhuntProductsList');
    } else {
        container = el.querySelector('#template_huntItemShellhuntProductsTile');
    }

    api_url = el.getAttribute('api_url');
    show_no_of_products = el.getAttribute('show_number_of_products');
    show_pagination = el.getAttribute('show_pagination');
    category_hashtag = el.getAttribute('category_hashtag');
    company_name = el.getAttribute('company_name');
    format_css = el.getAttribute('format_css');

    if (format_css === null) {
    } else {
        var link = $("<link />", {
            rel: "stylesheet",
            type: "text/css",
            href: format_css
        })
        $('#products-plugin').append(link);
    }

    if (layout_type === 'search-results') {

        var query = getQueryVariable("query");

        /* include category_hashtag here.  this will allow inbound links to specify either query OR hashtags by using &category_hashtag= */
        var category_hashtag = getQueryVariable("category_hashtag");

        function getQueryVariable(variable) {
            var query = window.location.search.substring(1);
            var vars = query.split("&");
            for (var i = 0; i < vars.length; i++) {
                var pair = vars[i].split("=");
                if (pair[0] == variable) {
                    return pair[1];
                }
            }
            // alert('Query Variable ' + variable + ' not found');
        }
    }

    if (!company_name) {
        alert("Please Insert company name...")
        return false;
    }
    jQuery.get(api_url, {
        selectPage: 3,
        show_pagination: show_pagination,
        show_number_of_products: show_no_of_products,
        page: page,
        category_hashtag: category_hashtag,
        company_name: company_name,
        query: query,
        layout_type: layout_type
    }, function (response) {
        if (response.success === true || response.success === 'true') {
            respond.products.renderProducts(layout_type, response, container, page, api_url, show_no_of_products, show_pagination, category_hashtag, company_name);
            if (show_pagination === 'Yes' && Number(response.total_records) > Number(show_no_of_products)) {
                $(function () {
                    $("#pagination").pagination({
                        items: response.total_records,
                        itemsOnPage: show_no_of_products,
                        category_hashtag: category_hashtag,
                        company_name: company_name,
                        query: query,
                        layout_type: layout_type,
                        cssStyle: 'light-theme',
                        onPageClick: (function (page, event) {
                            respond.products.nextPage(layout_type, page, container, api_url, show_no_of_products, show_pagination, category_hashtag, company_name);
                        })
                    }).pagination('selectPage', page);
                });
            }
        } else {
            /*alert(response.error);*/
            $('#hunt_products').removeClass('gr-hide');
            $('#hunt_products').html('');
            $('#hunt_products').html(response.error);
        }
    });
});


$(document).on("click", '.page-link', function (event) {
    $('html, body').stop(true, false).animate({
        scrollTop:0
    }, 2000);
});


rodeo.rodeoProductAll = (function (layout_type, response, container, page, api_url, show_no_of_products, show_pagination, category_hashtag, company_name) {
    var product, pro;
    if (layout_type === 'list') {
        for (var i = 0; i < response.products.length; i++) {

            pro = response.products[i];
            product = $(container).clone();
            product.find('.hunt-tile-block-header-products-list a').html(pro.productName);
            product.find('.hunt-tile-block-header-products-list a').prop("href", pro.productURL);
            product.find('.hunt-tile-block-header-products-list a').attr("data-id", pro.productID);
            product.find('a.gr-product-url-list-title').prop("href", pro.productURL);
            product.find('a.gr-product-url-list-title').attr("data-id", pro.productID);
            product.removeAttr("id");
            product.removeClass('gr-hide');
            product.addClass('huntItemShellhuntProductsList');
            $('#hunt_products').append(product);
        }
    } else {
        for (var i = 0; i < response.products.length; i++) {
            pro = response.products[i];
            product = $(container).clone();
            product.find('.hunt-tile-block-header-products a').html(pro.productName);
            product.find('.hunt-tile-block-header-products a').prop("href", pro.productURL);
            product.find('.hunt-tile-block-header-products a').attr("data-id", pro.productID);
            product.find('a.gr-product-url-prod').prop("href", pro.productURL);
            product.find('a.gr-product-url-prod').attr("data-id", pro.productID);
            product.find('.hunt-tile-block-btn.gr-text-center a').html("$" + pro.price);
            product.find('.gr-img-responsive').attr("src", pro.mainImage);
            product.removeAttr("id");
            product.removeClass('gr-hide');
            product.addClass('huntItemShellhuntTile');
            $('#hunt_products').append(product);
        }
    }
    $('#hunt_products').removeClass('gr-hide');
});
